#ifndef NO_FOCUS_SLIDER
#define NO_FOCUS_SLIDER

#include <QtGui>
#include <climits>
#include <cassert>
#include "sliderULongLong.h"

class SliderWithTextMaxCurrent : public SliderULongLong {
Q_OBJECT
private:
	QString text_;
	QString maxString_;
	QString currentString_;
	QString unit_;

	bool showMaximum_;
	bool showCurrent_;

	int fontSize_;
	int fontWeight_;
	QColor fontColor_;

	QString maximumPrefix_;
	QString currentPrefix_;
	QString maximumSuffix_;
public:
	SliderWithTextMaxCurrent(QWidget * parent);
protected:
	virtual void valueChangedEvent();

	virtual void paintEvent(QPaintEvent * paintEvent);
public:
	void setFontSize(int size, int weight);
	void setFontColor(const QColor & color);

	void showMaximum(bool show);
	void showCurrent(bool show);

	void setName(const std::wstring & name);

	void setUnit(const std::wstring & unit);

	void setMaximum(unsigned long long max);

	void setLimits(unsigned long long min, unsigned long long max);

	void setValue(unsigned long long value);

	void drawRotatedText(QPainter * painter, float degrees, int x, int y, const QString &text);

	void setMaximumPrefix(const std::wstring & value);
	void setCurrentPrefix(const std::wstring & value);

	void setMaximumSuffix(const std::wstring & suffix);
	
};

#endif